## New Project

<< project description >>

### Checklist

**Acknowledgements**

- [ ] I certify that I am authorized to assign ownership of this code to the OpenTelemetry project.
- [ ] I acknowledge that ownership of the [Hex](https://hex.pm) package must be given/transferred to the [OpenTelemetry Hex Org](https://hex.pm/orgs/opentelemetry)


**Project Type**

- [ ] Instrumentation
- [ ] Exporter
- [ ] Propagator
- [ ] Metapackage
- [ ] Example
- [ ] Util

**Prior Art**

- [ ] Is this an existing project? Includes private libraries being open sourced.
  - [ ] Yes
  - [ ] No
- [ ] Are there any other packages on [Hex](https://hex.pm) providing similar functionality?
  
**Existing Project**

- [ ] Moving from an existing public repository? Provide a link in the description.
- [ ] All authors who have contributed code contained in this PR have signed the [CNCF CLA](https://identity.linuxfoundation.org/projects/cncf)

**All Projects**

- [ ] Label created (maintainers)
- [ ] [labeler.yml](https://github.com/open-telemetry/opentelemetry-erlang-contrib/blob/main/.github/labeler.yml) updated
- [ ] CI
  - [ ] Elixir or Erlang language file is updated
  - [ ] Test strategy should use the matrix strategy with all supported language/OTP combinations
  - [ ] The job is scoped to only run for relevant code changes
- [ ] [Codeowners](https://github.com/open-telemetry/opentelemetry-erlang-contrib/blob/main/CODEOWNERS) adds scoped ownership for project maintainers
- [ ] License file (Apache2 - copyright to OpenTelemetry Authors)
- [ ] All code complies with the [Otel Specification](https://github.com/open-telemetry/opentelemetry-specification/tree/main/specification) and Otel Semantic Conventions - [Trace](https://github.com/open-telemetry/opentelemetry-specification/tree/main/specification/trace/semantic_conventions) [Metrics](https://github.com/open-telemetry/opentelemetry-specification/tree/main/specification/metrics/semantic_conventions)
